/*!
	Document:      gallery_view.js
	Date started:  26 July 2013
	By:            Matt Fozard
	Purpose:       Quru Image Server gallery viewer
	Requires:      common_view.js
	               canvas_view.js
	Copyright:     Quru Ltd (www.quru.com)
	Licence:

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU Affero General Public License as published
	by the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Affero General Public License for more details.

	You should have received a copy of the GNU Affero General Public License
	along with this program.  If not, see http://www.gnu.org/licenses/
*/
function GalleryView(a,c,b){this.options={server:"",folder:"",images:[],params:{},startImage:"",thumbsize:{width:120,height:120},viewer:{},stripaligns:true};
if(c!==undefined){this.options=QU.merge(this.options,c);}this.events=b;this.options.server=this._add_slash(this.options.server);
this.options.folder=this._add_slash(this.options.folder);this.options.images.forEach(function(d){if(d.server){d.server=this._add_slash(d.server);
}}.bind(this));this.firstIdx=0;this.thumbIdx=-1;this.thumbnails=[];this.touchAttrs={last:{x:0,y:0}};this.ctrEl=QU.id(a);
QU.elClear(this.ctrEl);this.elements={};this.create_ui();this.layout();}GalleryView.prototype.init=function(){this.setMessage("Loading gallery...");
if(this.options.folder){this.addFolderImages();}else{this.onDataReady(null);}};GalleryView.prototype.destroy=function(){this.events=null;
if(this.elements.main_view&&this.elements.main_view._viewer){this.elements.main_view._viewer.destroy();
}QU.elClear(this.ctrEl);};GalleryView.prototype.create_ui=function(){var h=document.createElement("div");
h.className="gallery";this.ctrEl.appendChild(h);var g=document.createElement("div");g.className="main_view";
g.style.textAlign="center";var f=document.createElement("div");f.className="thumbnails";f.style.overflow="hidden";
f.style.position="relative";h.appendChild(g);h.appendChild(f);var e=document.createElement("a");e.className="scroll_button disabled";
e.innerHTML="&lt;";QU.elSetStyles(e,{display:"block",position:"absolute",zIndex:"1",top:"0",left:"0",margin:"0"});
var a=document.createElement("a");a.className="scroll_button disabled";a.innerHTML="&gt;";QU.elSetStyles(a,{display:"block",position:"absolute",zIndex:"1",top:"0",right:"0",margin:"0"});
f.appendChild(e);f.appendChild(a);var b=document.createElement("div");b.className="scroller_viewport";
b.style.overflow="hidden";b.style.marginLeft=e.offsetWidth+"px";var d=document.createElement("div");d.style.overflow="auto";
var c=document.createElement("div");c.className="scroller";c.style.position="relative";c.style.whiteSpace="nowrap";
d.appendChild(c);b.appendChild(d);f.appendChild(b);d.addEventListener("scroll",function(){this.onThumbsScroll();
}.bind(this),false);e.addEventListener("click",function(){this.scrollRelative(-1);return false;}.bind(this),false);
a.addEventListener("click",function(){this.scrollRelative(1);return false;}.bind(this),false);this.elements={wrapper:h,main_view:g,tn_wrapper:f,tn_viewport:b,tn_scrollable:d,tn_panel:c,tn_left:e,tn_right:a};
this.scroller=new ElementScroller(d,500,Math.easeInOutSine);};GalleryView.prototype.layout=function(){var c=QU.elInnerSize(this.ctrEl,false),h=QU.elGetStyles(this.elements.wrapper,["marginTop","paddingTop","borderTopWidth","marginBottom","paddingBottom","borderBottomWidth"]),d=Math.round(this._sum_object_floats(h)),j=QU.elGetStyles(this.elements.tn_wrapper,["marginTop","paddingTop","borderTopWidth","marginBottom","paddingBottom","borderBottomWidth"]),b=Math.round(this._sum_object_floats(j)),e=this.options.thumbsize.height+12,f=c.height-(d+b+e);
if(f%2==1){f--;}this.elements.main_view.style.height=f+"px";this.elements.main_view.style.lineHeight=f+"px";
this.elements.tn_wrapper.style.height=e+"px";this.elements.tn_wrapper.style.lineHeight=e+"px";this.elements.tn_left.style.height=e+"px";
this.elements.tn_left.style.lineHeight=e+"px";this.elements.tn_right.style.height=e+"px";this.elements.tn_right.style.lineHeight=e+"px";
var a=this.elements.tn_wrapper.offsetWidth,i=this.elements.tn_left.offsetWidth,g=a-(2*i);this.elements.tn_viewport.style.width=g+"px";
this.elements.tn_viewport.style.height=e+"px";this.elements.tn_scrollable.style.width=g+"px";this.elements.tn_panel.style.height=e+"px";
this.elements.tn_panel.style.lineHeight=e-4+"px";canvas_view_resize(this.elements.main_view);};GalleryView.prototype.setMessage=function(a){this.elements.main_view.innerHTML='<span style="font-size: small">'+a+"</span>";
};GalleryView.prototype.addFolderImages=function(){var a=this.options.server+"api/v1/list/?path="+encodeURIComponent(this.options.folder);
QU.jsonRequest(a,"GET",function(c,b){this.onDataReady(b);}.bind(this),function(c,b){this.setMessage("");
}.bind(this)).send();};GalleryView.prototype.onDataReady=function(h){if(h&&(h.status==200)){for(var d=0;
d<h.data.length;d++){var b=h.data[d];if(b.supported){this.options.images.push({src:this.options.folder+b.filename});
}}}if(this.options.images.length>0){var a=[],j=false;for(var d=0;d<this.options.images.length;d++){var f=this.options.images[d],e={};
e=QU.merge(e,this.options.params);e=QU.merge(e,f);delete e.server;delete e.title;delete e.description;
e.width=this.options.thumbsize.width;e.height=this.options.thumbsize.height;e.strip=1;if(!e.format){e.format="png";
}if(!e.fill){e.fill="none";}if(this.options.stripaligns){delete e.halign;delete e.valign;}var c=f.server?f.server:this.options.server,g=c+"image?"+QU.ObjectToQueryString(e);
if(a.indexOf(g)===-1){if((this.options.startImage===e.src)&&!j){this.firstIdx=d;j=true;}a.push(g);this.addThumbnail(g,d,f.title,f.description);
}}this.setScrollButtons();}else{this.setMessage("There are no images to display");}};GalleryView.prototype.addThumbnail=function(g,a,f,b){var c=document.createElement("img");
c.src=g;c.setAttribute("data-index",a);c.title=f?f:"";c.draggable=false;if(f){c.setAttribute("data-title",f);
}if(b){c.setAttribute("data-description",b);}this.thumbnails.push(c);this.elements.tn_panel.appendChild(c);
c.addEventListener("load",function(){this.onThumbLoaded(c,a);}.bind(this),false);try{c.addEventListener("touchstart",function(h){this.onThumbTouchStart(h,a);
}.bind(this),false);c.addEventListener("touchend",function(h){this.onThumbTouchEnd(h,a);}.bind(this),false);
}catch(d){}try{c.addEventListener("click",function(){this.onThumbClick(c,a);}.bind(this),false);}catch(d){}};
GalleryView.prototype.onThumbLoaded=function(b,a){this.setScrollButtons();if(this.firstIdx===a){this.moveDirect(a);
}};GalleryView.prototype.onThumbTouchStart=function(b,a){if(b.touches.length===1){this.touchAttrs.last.x=b.touches[0].pageX;
this.touchAttrs.last.y=b.touches[0].pageY;}return true;};GalleryView.prototype.onThumbTouchEnd=function(b,a){if(Math.abs(this.touchAttrs.last.x-b.changedTouches[0].pageX)<10&&Math.abs(this.touchAttrs.last.y-b.changedTouches[0].pageY)<10){this.onThumbClick(b.target,a);
}return true;};GalleryView.prototype.onThumbClick=function(b,a){this.moveDirect(a);};GalleryView.prototype.scrollDirect=function(a,c){if(this.thumbnails.length){var d=this.getScrollInfo(),a=Math.max(0,Math.min(this.thumbnails.length-1,a));
if(c==="left"){if(a>0){var b=this.thumbnails[a];this.scroller.scrollTo(b.offsetLeft-d.thumbMargin,0);
}else{this.scroller.scrollTo(0,0);}}else{if(a<(this.thumbnails.length-1)){var e=this.thumbnails[a+1];
this.scroller.scrollTo(e.offsetLeft-d.viewportWidth,0);}else{this.scroller.scrollTo(d.scrollTotal-d.viewportWidth,0);
}}}};GalleryView.prototype.scrollRelative=function(b){if(this.thumbnails.length&&b){var a=this.getScrollInfo();
if(b<0){if(a.scrollFrom>0){this.scrollDirect(a.startThumbIdx+b,"left");}}else{if(a.scrollTo<a.scrollTotal){this.scrollDirect(a.endThumbIdx+b,"right");
}}}};GalleryView.prototype.moveRelative=function(a){if(this.thumbnails.length&&a){this.moveDirect(this.thumbIdx+a);
}};GalleryView.prototype.moveDirect=function(a){if(this.thumbnails.length){a=Math.max(0,Math.min(this.thumbnails.length-1,a));
if(a!==this.thumbIdx){this.thumbIdx=a;this.thumbnails.forEach(function(b){QU.elSetClass(b,"selected",false);
});QU.elSetClass(this.thumbnails[a],"selected",true);if(this.moveTimer!==undefined){clearTimeout(this.moveTimer);
}this.moveTimer=setTimeout(this.onMoveComplete.bind(this),100);}}};GalleryView.prototype.onMoveComplete=function(){delete this.moveTimer;
this.autoThumbScroll();var b=this.thumbnails[this.thumbIdx],a=QU.clone(this.options.viewer);if(b.getAttribute("data-title")!=null){a.title=b.getAttribute("data-title");
}if(b.getAttribute("data-description")!=null){a.description=b.getAttribute("data-description");}if(this.events){ImgUtils.fireEvent(this.events.onchange,this,[this.options.images[this.thumbIdx].src]);
}canvas_view_init(this.elements.main_view,b.src,a,this.events);};GalleryView.prototype.onThumbsScroll=function(){if(this.scrollTimer!==undefined){clearTimeout(this.scrollTimer);
}this.scrollTimer=setTimeout(this.onThumbsScrollComplete.bind(this),100);};GalleryView.prototype.onThumbsScrollComplete=function(){delete this.scrollTimer;
this.setScrollButtons();if(this.autoScrollIdx!==undefined){if(this.autoScrollIdx!==this.thumbIdx){delete this.autoScrollIdx;
this.autoThumbScroll();}else{delete this.autoScrollIdx;}}};GalleryView.prototype.autoThumbScroll=function(){var a=this.thumbIdx,b=this.getScrollInfo();
if(this.autoScrollIdx===undefined){this.autoScrollIdx=a;}if(a===b.startThumbIdx){this.scrollRelative(-1);
}else{if(a===b.endThumbIdx){this.scrollRelative(1);}else{if(a<b.startThumbIdx){this.scrollDirect(a,"left");
}else{if(a>b.endThumbIdx){this.scrollDirect(a,"right");}else{delete this.autoScrollIdx;}}}}};GalleryView.prototype.getScrollInfo=function(){var g=this.elements.tn_scrollable,b=this.elements.tn_panel,o=g.parentNode,e=g.scrollLeft,a=Math.max(g.scrollWidth,b.scrollWidth),m=o.clientWidth,n=e+m;
var j=-1,d=-1,h=this.thumbnails[0].offsetWidth;for(var f=0;f<this.thumbnails.length;f++){var p=this.thumbnails[f],c=((p.offsetLeft+h)<=e)||(p.offsetLeft>=n);
if(!c){if(j==-1){j=f;}d=Math.max(d,f);}if(c&&(d!=-1)){break;}}var k=QU.elGetStyles(this.thumbnails[0],["marginLeft","marginRight"]),l=Math.round((parseFloat(k.marginLeft)+parseFloat(k.marginRight))/2);
return{scrollFrom:e,scrollTo:n,scrollTotal:a,viewportWidth:m,thumbMargin:l,startThumbIdx:j,endThumbIdx:d};
};GalleryView.prototype.setScrollButtons=function(){var a=this.getScrollInfo();if(a.scrollFrom<=0){QU.elSetClass(this.elements.tn_left,"disabled",true);
}else{QU.elSetClass(this.elements.tn_left,"disabled",false);}if(a.scrollTo>=a.scrollTotal){QU.elSetClass(this.elements.tn_right,"disabled",true);
}else{QU.elSetClass(this.elements.tn_right,"disabled",false);}};GalleryView.prototype._add_slash=function(a){if(a&&a.charAt(a.length-1)!="/"){return a+"/";
}else{return a;}};GalleryView.prototype._sum_object_floats=function(d){var b,c,a=0;for(b in d){c=parseFloat(d[b]);
if(!isNaN(c)){a+=c;}}return a;};function GalleryViewMask(a,b){this.options=a;this.events=b;if(!this.options){this.options={};
}if(!this.options.viewer){this.options.viewer={};}if(!this.options.viewer.controls){this.options.viewer.controls={};
}this.options.viewer.controls.fullscreen=false;this.fullScreenFixed=true;this.animating=false;this.ctrEl=null;
this.mask=null;this.fullKeydownFn=function(c){this.fullscreenKeydown(c);}.bind(this);this.fullResizeFn=function(c){this.fullscreenResize(c);
}.bind(this);}GalleryViewMask.prototype.open=function(){var b=this.fullscreenGetCoords();this.mask=new PageMask("fullscreen_mask",{zIndex:"1000"},function(d){this.close();
}.bind(this));this.mask.show();this.ctrEl=document.createElement("div");this.ctrEl.className="fullscreen";
QU.elSetStyles(this.ctrEl,{position:this.fullScreenFixed?"fixed":"absolute",zIndex:"1001",opacity:"0",left:b.left+"px",top:b.top+"px",width:b.width+"px",height:b.height+"px",margin:"0",padding:"0"});
document.body.insertBefore(this.ctrEl,document.body.firstChild);var c=document.createElement("a");c.className="close_button";
QU.elSetStyles(c,{display:"block",position:"absolute",zIndex:"1102",top:"0px",right:"0px",width:"33px",height:"33px"});
c.addEventListener("click",this.close.bind(this),false);window.addEventListener("keydown",this.fullKeydownFn,false);
window.addEventListener("resize",this.fullResizeFn,false);gallery_view_init(this.ctrEl,this.options,this.events);
var a=this.ctrEl.querySelector(".gallery");a.insertBefore(c,a.firstChild);this.fader=new ElementFader(this.ctrEl,300);
this.fader.fadeIn();if(this.events){ImgUtils.fireEvent(this.events.onfullscreen,this.ctrEl._gallery,["",true]);
}};GalleryViewMask.prototype.close=function(){if(this.animating){return;}this.animating=true;this.fader.fadeOut(function(){if(this.events){ImgUtils.fireEvent(this.events.onfullscreen,this.ctrEl._gallery,["",false]);
}window.removeEventListener("resize",this.fullResizeFn,false);window.removeEventListener("keydown",this.fullKeydownFn,false);
if(this.ctrEl._gallery){this.ctrEl._gallery.destroy();}QU.elRemove(this.ctrEl);this.ctrEl=null;this.mask.destroy();
this.mask=null;this.animating=false;}.bind(this));};GalleryViewMask.prototype.fullscreenKeydown=function(b){var a=(b.which||b.keyCode);
switch(a){case 27:b.preventDefault();b.stopPropagation();setTimeout(this.close.bind(this),1);break;case 37:case 40:b.preventDefault();
b.stopPropagation();if(this.ctrEl._gallery){this.ctrEl._gallery.moveRelative(-1);}break;case 39:case 38:b.preventDefault();
b.stopPropagation();if(this.ctrEl._gallery){this.ctrEl._gallery.moveRelative(1);}break;}};GalleryViewMask.prototype.fullscreenResize=function(b){var a=this.fullscreenGetCoords();
QU.elSetStyles(this.ctrEl,{left:a.left+"px",top:a.top+"px",width:a.width+"px",height:a.height+"px"});
if(this.ctrEl._gallery){this.ctrEl._gallery.layout();}};GalleryViewMask.prototype.fullscreenGetCoords=function(){var c=window.innerWidth?{x:window.innerWidth,y:window.innerHeight}:{x:document.body.clientWidth,y:document.body.clientHeight},a=this.fullScreenFixed?{x:0,y:0}:{x:window.pageXOffset,y:window.pageYOffset},f=Math.min(Math.round(c.x/40),Math.round(c.y/40));
var d=(a.x+f),e=(a.y+f),b=(c.x-(2*f)),g=(c.y-(2*f));return{left:d,top:e,width:Math.max(b,250),height:Math.max(g,250)};
};function gallery_view_init(b,c,d){b=QU.id(b);if(b){var a=new GalleryView(b,c,d);a.init();b._gallery=a;
}return false;}function gallery_view_resize(a){a=QU.id(a);if(a&&a._gallery){a._gallery.layout();}return false;
}function gallery_view_init_fullscreen(c,a,b){c=QU.id(c);if(c){var d=a?QU.clone(a):{};if(c._onlick){c.removeEventListener("click",c._onlick,false);
}c._onlick=function(){if(!d.startImage){var e=ImgUtils.getImageSrc(c);if(e){var g=QU.splitURL(e),f=QU.QueryStringToObject(g.query,false);
if(f.src){d.startImage=f.src;}}}(new GalleryViewMask(d,b)).open();};c.addEventListener("click",c._onlick,false);
}return false;}function gallery_view_init_all_fullscreen(j,m,l){var a=document.querySelectorAll("."+j);
if(a.length>0){var m=m||{};m.images=m.images||[];for(var f=0;f<a.length;f++){var g=a[f],d=ImgUtils.getImageSrc(g);
if(d){var b=QU.splitURL(d),e=QU.QueryStringToObject(b.query,false);if(e.src){var k=b.protocol+b.server+"/";
var c=g.title||g.alt;var h={server:k};if(c){h.title=c;}h=QU.merge(h,e);m.images.push(h);if(!m.server){m.server=k;
}}}}if(m.images.length>0){for(var f=0;f<a.length;f++){gallery_view_init_fullscreen(a[f],m,l);}}}return false;
}
/*!
    Document:      common_view.js
    Date started:  12 September 2017
    By:            Matt Fozard
    Purpose:       Quru Image Server viewer utilities and common routines
    Requires:
    Copyright:     Quru Ltd (www.quru.com)
    Licence:

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published
    by the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/
*/
if(!window.QU){QU={version:1,supported:([].forEach!==undefined)&&([].indexOf!==undefined)&&((function(){}).bind!==undefined)&&(Object.keys!==undefined)&&(window.addEventListener!==undefined)&&(window.getComputedStyle!==undefined)&&(window.pageXOffset!==undefined)&&(window.JSON!==undefined)};
QU.id=function(a){if(typeof a==="number"){a=""+a;}if(typeof a==="string"){return document.getElementById(a);
}if(typeof a==="object"){return a;}return null;};QU.elClear=function(a){a=QU.id(a);while(a.firstChild){a.removeChild(a.firstChild);
}return a;};QU.elRemove=function(a){a=QU.id(a);if(a&&a.parentNode){a.parentNode.removeChild(a);}return a;
};QU.elOuterPosition=function(c){c=QU.id(c);var d=c,a=0,b=0;if(d.offsetParent){do{a+=d.offsetLeft;b+=d.offsetTop;
}while(d=d.offsetParent);}return{x:a,y:b,width:c.offsetWidth,height:c.offsetHeight};};QU.elInnerSize=function(c,a){c=QU.id(c);
var d={width:c.clientWidth,height:c.clientHeight};if(!a){var b=window.getComputedStyle(c);d.width-=Math.round(parseFloat(b.paddingLeft)+parseFloat(b.paddingRight));
d.height-=Math.round(parseFloat(b.paddingTop)+parseFloat(b.paddingBottom));d.width=Math.max(d.width,0);
d.height=Math.max(d.height,0);}return d;};QU.elInnerOffsets=function(b){b=QU.id(b);var a=window.getComputedStyle(b);
return{left:Math.round(parseFloat(a.paddingLeft)+parseFloat(a.borderLeftWidth)),right:Math.round(parseFloat(a.paddingRight)+parseFloat(a.borderRightWidth)),top:Math.round(parseFloat(a.paddingTop)+parseFloat(a.borderTopWidth)),bottom:Math.round(parseFloat(a.paddingBottom)+parseFloat(a.borderBottomWidth))};
};QU.elSetClass=function(d,c,e){d=QU.id(d);if(d.classList){if(e){d.classList.add(c);}else{d.classList.remove(c);
}}else{var b=d.className.split(" "),a=b.indexOf(c);if(b.length===1&&b[0]===""){b.length=0;}if(e&&(a===-1)){b.push(c);
}else{if(!e&&(a!==-1)){b.splice(a,1);}}d.className=b.join(" ");}return d;};QU.elHasClass=function(c,b){c=QU.id(c);
if(c.classList){return c.classList.contains(b);}else{var a=c.className.split(" ");return a.indexOf(b)!==-1;
}};QU.elGetStyles=function(c,g){c=QU.id(c);var b,f={};if(g){try{b=window.getComputedStyle(c);}catch(d){}if(b){for(var a=0;
a<g.length;a++){f[g[a]]=b[g[a]];}}}return f;};QU.elSetStyles=function(b,c){b=QU.id(b);if(c){for(var a in c){b.style[a]=c[a];
}}return b;};QU.evPosition=function(b){var c={x:0,y:0},a={x:0,y:0};if(b.type.indexOf("touch")==0||b.type.indexOf("gesture")==0){if(b.touches&&b.touches[0]){var e=b.touches[0];
c.x=e.pageX;c.y=e.pageY;a.x=e.clientX;a.y=e.clientY;}}else{var d=document.documentElement||document.body;
c.x=(b.pageX!=null)?b.pageX:b.clientX+d.scrollLeft;c.y=(b.pageY!=null)?b.pageY:b.clientY+d.scrollTop;
a.x=(b.pageX!=null)?b.pageX-window.pageXOffset:b.clientX;a.y=(b.pageY!=null)?b.pageY-window.pageYOffset:b.clientY;
}return{page:c,viewport:a};};QU.jsonRequest=function(b,e,a,d){var c=new XMLHttpRequest();if("withCredentials" in c){c.open(e,b,true);
c.setRequestHeader("Accept","application/json");}else{if(typeof XDomainRequest!=="undefined"){c=new XDomainRequest();
c._XDR=true;c.onprogress=function(){};c.ontimeout=function(){};c.open(e,b);}else{return null;}}c.onload=function(){if(!c._XDR&&(c.status<200||c.status>=400)){if(d){d(c,c.responseText);
}return;}if(a){var g;try{g=JSON.parse(c.responseText);}catch(f){if(d){d(c,"Invalid JSON: "+f);}return;
}a(c,g);}};c.onerror=function(){if(d){d(c,c.responseText);}};return c;};QU.splitURL=function(d){var a,c,b,e={protocol:"",server:"",path:"",query:"",fragment:""};
a=d.indexOf("//");if(a!==-1){e.protocol=d.substring(0,a+2);d=d.substring(a+2);}a=d.indexOf("/");if(a>=1){e.server=d.substring(0,a);
d=d.substring(a);}c=d.indexOf("?");if(c!==-1){e.path=d.substring(0,c);e.query=d.substring(c+1);b=e.query.indexOf("#");
if(b!==-1){e.fragment=e.query.substring(b+1);e.query=e.query.substring(0,b);}}else{e.path=d;b=e.path.indexOf("#");
if(b!==-1){e.fragment=e.path.substring(b+1);e.path=e.path.substring(0,b);}}return e;};QU.ObjectToQueryString=function(a,c){var d=[];
var b=Object.keys(a);b.forEach(function(g){var h=a[g],f;if(c){g=c+"["+g+"]";}switch(typeof h){case"object":f=QU.ObjectToQueryString(h,g);
break;case"array":var e={};h.forEach(function(k,j){e[j]=k;});f=QU.ObjectToQueryString(e,g);break;default:f=g+"="+encodeURIComponent(h);
}if(h!=null){d.push(f);}});return d.join("&");};QU.QueryStringToObject=function(g,d){if(d===undefined){d=true;
}var a=function(h){return decodeURIComponent(h.replace(/\+/g," "));};var f=true,b=true;var e=g.split(/[&;]/),c={};
if(!e.length){return c;}e.forEach(function(l){var h=l.indexOf("=")+1,j=h?l.substr(h):"",i=h?l.substr(0,h-1).match(/([^\]\[]+|(\B)(?=\]))/g):[l],k=c;
if(!i){return;}if(!d&&!j){return;}if(b){j=a(j);}i.forEach(function(n,m){if(f){n=a(n);}var o=k[n];if(m<i.length-1){k=k[n]=o||{};
}else{if(typeof o==="array"){o.push(j);}else{k[n]=o!=null?[o,j]:j;}}});});return c;};QU.whenReady=function(a){if(document.attachEvent?document.readyState==="complete":document.readyState!=="loading"){a();
}else{document.addEventListener("DOMContentLoaded",a);}};QU.clone=function(a){if((a===null)||(a===undefined)){return a;
}return JSON.parse(JSON.stringify(a));};QU.merge=function(f,e){var d=function(h,i,j){switch(typeof j){case"object":if(typeof h[i]=="object"){QU.merge(h[i],j);
}else{h[i]=QU.clone(j);}break;case"array":h[i]=QU.clone(j);break;default:h[i]=j;}return h;};for(var c=1,a=arguments.length;
c<a;c++){var g=arguments[c];if((g!==null)&&(g!==undefined)){for(var b in g){d(f,b,g[b]);}}}return f;};
}